Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Parameters_print.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Parameters_print.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Parameters_print.cpp	(revision 88)
@@ -0,0 +1,91 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Dcache_Access/include/Parameters.h"
+#include "Behavioural/include/XML.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace dcache_access {
+
+
+#undef  FUNCTION
+#define FUNCTION "Dcache_Access::print"
+  std::string Parameters::print (uint32_t depth)
+  {
+    log_begin(Dcache_Access,FUNCTION);
+
+    XML xml ("dcache_access");
+
+    xml.balise_open("dcache_access");
+    xml.singleton_begin("nb_execute_loop        "); xml.attribut("value",toString(_nb_execute_loop        )); xml.singleton_end();
+    xml.singleton_begin("nb_dcache_port         "); xml.attribut("value",toString(_nb_dcache_port         )); xml.singleton_end();
+    xml.singleton_begin("size_address           "); xml.attribut("value",toString(_size_address           )); xml.singleton_end();
+    xml.singleton_begin("size_data              "); xml.attribut("value",toString(_size_data              )); xml.singleton_end();
+    xml.singleton_begin("priority               "); xml.attribut("value",toString(_priority               )); xml.singleton_end();
+    xml.singleton_begin("load_balancing         "); xml.attribut("value",toString(_load_balancing         )); xml.singleton_end();
+
+    for (uint32_t i=0;i<_nb_execute_loop; i++)
+      {
+        xml. balise_open_begin("component");
+        xml.  attribut("type","execute_loop");
+        xml.  attribut("id"  ,toString(i));
+        xml. balise_open_end();
+	xml.singleton_begin("nb_load_store_unit     "); xml.attribut("value",toString(_nb_load_store_unit     [i])); xml.singleton_end();
+	
+	for (uint32_t j=0; j<_nb_load_store_unit [i]; ++j)
+	  {
+	    xml. balise_open_begin("component");
+	    xml.  attribut("type","load_store_unit");
+	    xml.  attribut("id"  ,toString(j));
+	    xml. balise_open_end();
+	    xml.singleton_begin("nb_cache_access        "); xml.attribut("value",toString(_nb_cache_access        [i][j])); xml.singleton_end();
+	    xml.singleton_begin("size_thread_id         "); xml.attribut("value",toString(_size_thread_id         [i][j])); xml.singleton_end();
+	    xml.singleton_begin("size_packet_id         "); xml.attribut("value",toString(_size_packet_id         [i][j])); xml.singleton_end();
+
+	    for (uint32_t k=0; k<_nb_cache_access [i][j]; ++k)
+	      {
+		xml. balise_open_begin("component");
+		xml.  attribut("type","cache_access");
+		xml.  attribut("id"  ,toString(k));
+		xml. balise_open_end();
+		xml.singleton_begin("table_routing          "); xml.attribut("value",toString(_table_routing          [i][j][k])); xml.singleton_end();
+		
+		xml. balise_close();
+	      }
+	    xml. balise_close();
+	  }
+	xml. balise_close();
+      }
+
+    xml.balise_close();
+
+    log_end(Dcache_Access,FUNCTION);
+    
+    return xml.get_body(depth);
+  };
+
+#undef  FUNCTION
+#define FUNCTION "Dcache_Access::operator<<"
+  std::ostream& operator<< (std::ostream& output_stream ,
+			    morpheo::behavioural::core::dcache_access::Parameters & x)
+  {
+    log_begin(Dcache_Access,FUNCTION);
+
+    output_stream << x.print(0);
+    
+    log_end(Dcache_Access,FUNCTION);
+
+    return output_stream;
+  };
+
+}; // end namespace dcache_access
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/Makefile
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/Makefile	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/Makefile	(revision 88)
@@ -0,0 +1,24 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+
+#-----[ Directory ]----------------------------------------
+DIR_COMPONENT			= ./
+include				$(DIR_COMPONENT)/Makefile.defs
+
+#-----[ Library ]------------------------------------------
+LIBRARY				= $(DIR_LIB)/libIcache_Access.a
+
+
+#-----[ include ]------------------------------------------
+
+all				:
+				@$(MAKE) all_component
+
+include                         $(DIR_MORPHEO)/Behavioural/Makefile.flags
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Common
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Component
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/Makefile.defs
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/Makefile.defs	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/Makefile.defs	(revision 88)
@@ -0,0 +1,11 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+
+#-----[ Directory ]----------------------------------------
+DIR_COMPONENT_MORPHEO		= ../../..
+DIR_MORPHEO			= $(DIR_COMPONENT)/$(DIR_COMPONENT_MORPHEO)
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/Makefile.deps
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/Makefile.deps	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/Makefile.deps	(revision 88)
@@ -0,0 +1,45 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+# DIR_MORPHEO must be defined
+
+Icache_Access			= yes
+
+ifndef Behavioural
+include 			$(DIR_MORPHEO)/Behavioural/Makefile.deps
+endif
+ifndef Priority
+include 			$(DIR_MORPHEO)/Behavioural/Generic/Priority/Makefile.deps
+endif
+
+#-----[ Directory ]----------------------------------------
+
+Icache_Access_DIR		=	$(DIR_MORPHEO)/Behavioural/Core/Icache_Access
+
+#-----[ Library ]------------------------------------------
+
+Icache_Access_LIBRARY		= 	-lIcache_Access			\
+					$(Priority_LIBRARY)		\
+					$(Behavioural_LIBRARY)	
+
+Icache_Access_DIR_LIBRARY	=	-L$(Icache_Access_DIR)/lib	\
+					$(Priority_DIR_LIBRARY)		\
+					$(Behavioural_DIR_LIBRARY)
+
+#-----[ Rules ]--------------------------------------------
+
+Icache_Access_library		:
+				@\
+				$(MAKE) Behavioural_library;		\
+				$(MAKE) Priority_library;		\
+				$(MAKE) --directory=$(Icache_Access_DIR) --makefile=Makefile;
+
+Icache_Access_library_clean	:
+				@\
+				$(MAKE) Behavioural_library_clean;	\
+				$(MAKE) Priority_library_clean;		\
+				$(MAKE) --directory=$(Icache_Access_DIR) --makefile=Makefile clean;
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/SelfTest/Makefile
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/SelfTest/Makefile	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/SelfTest/Makefile	(revision 88)
@@ -0,0 +1,32 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+
+#-----[ Directory ]----------------------------------------
+DIR_COMPONENT			= ../
+include				$(DIR_COMPONENT)/Makefile.defs
+
+LIBRARY				= $(Icache_Access_LIBRARY)
+
+DIR_LIBRARY			= $(Icache_Access_DIR_LIBRARY)
+
+#-----[ include ]------------------------------------------
+
+all				:
+				@$(MAKE) all_selftest
+
+library				: Icache_Access_library
+
+library_clean			: Icache_Access_library_clean
+
+local_clean			:
+
+include                         $(DIR_COMPONENT)/Makefile.deps
+include                         $(DIR_MORPHEO)/Behavioural/Makefile.flags
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Common
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Selftest
+include 			$(DIR_MORPHEO)/Behavioural/Makefile.Synthesis
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/SelfTest/config_min.cfg
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/SelfTest/config_min.cfg	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/SelfTest/config_min.cfg	(revision 88)
@@ -0,0 +1,10 @@
+Icache_Access
+1	1	+1	# nb_front_end       
+1	1	+1	# nb_context     [0]    [nb_front_end]
+1	1	+1	# nb_icache_port
+30	30	+1	# size_address   
+1	1	+1	# nb_instruction [0][0] [nb_front_end][nb_context]
+0	0	+1	# size_packet_id [0][0] [nb_front_end][nb_context]
+0	0	+1	# table_routing  [0][0] [nb_front_end][nb_context]
+0	1	+1	# priority           
+0	1	+1	# load_balancing     
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/SelfTest/config_mono_front_end1.cfg
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/SelfTest/config_mono_front_end1.cfg	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/SelfTest/config_mono_front_end1.cfg	(revision 88)
@@ -0,0 +1,19 @@
+Icache_Access
+1	1	+1	# nb_front_end       
+4	4	+1	# nb_context     [0]    [nb_front_end]
+1	1	+1	# nb_icache_port
+30	30	+1	# size_address   
+1	1	+1	# nb_instruction [0][0] [nb_front_end][nb_context]
+2	2	+1	# nb_instruction [0][1] [nb_front_end][nb_context]
+4	4	+1	# nb_instruction [0][2] [nb_front_end][nb_context]
+8	8	+1	# nb_instruction [0][3] [nb_front_end][nb_context]
+2	2	+1	# size_packet_id [0][0] [nb_front_end][nb_context]
+3	3	+1	# size_packet_id [0][1] [nb_front_end][nb_context]
+0	0	+1	# size_packet_id [0][2] [nb_front_end][nb_context]
+1	1	+1	# size_packet_id [0][3] [nb_front_end][nb_context]
+0	0	+1	# table_routing  [0][0] [nb_front_end][nb_context]
+0	0	+1	# table_routing  [0][1] [nb_front_end][nb_context]
+0	0	+1	# table_routing  [0][2] [nb_front_end][nb_context]
+0	0	+1	# table_routing  [0][3] [nb_front_end][nb_context]
+0	1	+1	# priority           
+0	1	+1	# load_balancing     
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/SelfTest/config_mono_front_end2.cfg
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/SelfTest/config_mono_front_end2.cfg	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/SelfTest/config_mono_front_end2.cfg	(revision 88)
@@ -0,0 +1,19 @@
+Icache_Access
+1	1	+1	# nb_front_end       
+4	4	+1	# nb_context     [0]    [nb_front_end]
+2	2	+1	# nb_icache_port
+30	30	+1	# size_address   
+1	1	+1	# nb_instruction [0][0] [nb_front_end][nb_context]
+2	2	+1	# nb_instruction [0][1] [nb_front_end][nb_context]
+4	4	+1	# nb_instruction [0][2] [nb_front_end][nb_context]
+8	8	+1	# nb_instruction [0][3] [nb_front_end][nb_context]
+2	2	+1	# size_packet_id [0][0] [nb_front_end][nb_context]
+3	3	+1	# size_packet_id [0][1] [nb_front_end][nb_context]
+0	0	+1	# size_packet_id [0][2] [nb_front_end][nb_context]
+1	1	+1	# size_packet_id [0][3] [nb_front_end][nb_context]
+0	0	+1	# table_routing  [0][0] [nb_front_end][nb_context]
+1	1	+1	# table_routing  [0][1] [nb_front_end][nb_context]
+1	1	+1	# table_routing  [0][2] [nb_front_end][nb_context]
+0	0	+1	# table_routing  [0][3] [nb_front_end][nb_context]
+0	1	+1	# priority           
+0	1	+1	# load_balancing     
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/SelfTest/config_multi_front_end1.cfg
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/SelfTest/config_multi_front_end1.cfg	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/SelfTest/config_multi_front_end1.cfg	(revision 88)
@@ -0,0 +1,27 @@
+Icache_Access
+3	3	+1	# nb_front_end       
+1	1	+1	# nb_context     [0]    [nb_front_end]
+3	3	+1	# nb_context     [1]    [nb_front_end]
+2	2	+1	# nb_context     [2]    [nb_front_end]
+1	1	+1	# nb_icache_port
+30	30	+1	# size_address   
+1	1	+1	# nb_instruction [0][0] [nb_front_end][nb_context]
+2	2	+1	# nb_instruction [1][0] [nb_front_end][nb_context]
+3	3	+1	# nb_instruction [1][1] [nb_front_end][nb_context]
+2	2	+1	# nb_instruction [1][2] [nb_front_end][nb_context]
+4	4	+1	# nb_instruction [2][0] [nb_front_end][nb_context]
+4	4	+1	# nb_instruction [2][1] [nb_front_end][nb_context]
+2	2	+1	# size_packet_id [0][0] [nb_front_end][nb_context]
+3	3	+1	# size_packet_id [1][0] [nb_front_end][nb_context]
+3	3	+1	# size_packet_id [1][1] [nb_front_end][nb_context]
+0	0	+1	# size_packet_id [1][2] [nb_front_end][nb_context]
+1	1	+1	# size_packet_id [2][0] [nb_front_end][nb_context]
+1	1	+1	# size_packet_id [2][1] [nb_front_end][nb_context]
+0	0	+1	# table_routing  [0][0] [nb_front_end][nb_context]
+0	0	+1	# table_routing  [1][0] [nb_front_end][nb_context]
+0	0	+1	# table_routing  [1][1] [nb_front_end][nb_context]
+0	0	+1	# table_routing  [1][2] [nb_front_end][nb_context]
+0	0	+1	# table_routing  [2][0] [nb_front_end][nb_context]
+0	0	+1	# table_routing  [2][1] [nb_front_end][nb_context]
+0	1	+1	# priority           
+0	1	+1	# load_balancing     
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/SelfTest/config_multi_front_end2.cfg
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/SelfTest/config_multi_front_end2.cfg	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/SelfTest/config_multi_front_end2.cfg	(revision 88)
@@ -0,0 +1,27 @@
+Icache_Access
+3	3	+1	# nb_front_end       
+1	1	+1	# nb_context     [0]    [nb_front_end]
+3	3	+1	# nb_context     [1]    [nb_front_end]
+2	2	+1	# nb_context     [2]    [nb_front_end]
+2	2	+1	# nb_icache_port
+30	30	+1	# size_address   
+1	1	+1	# nb_instruction [0][0] [nb_front_end][nb_context]
+2	2	+1	# nb_instruction [1][0] [nb_front_end][nb_context]
+3	3	+1	# nb_instruction [1][1] [nb_front_end][nb_context]
+2	2	+1	# nb_instruction [1][2] [nb_front_end][nb_context]
+4	4	+1	# nb_instruction [2][0] [nb_front_end][nb_context]
+4	4	+1	# nb_instruction [2][1] [nb_front_end][nb_context]
+2	2	+1	# size_packet_id [0][0] [nb_front_end][nb_context]
+3	3	+1	# size_packet_id [1][0] [nb_front_end][nb_context]
+3	3	+1	# size_packet_id [1][1] [nb_front_end][nb_context]
+0	0	+1	# size_packet_id [1][2] [nb_front_end][nb_context]
+1	1	+1	# size_packet_id [2][0] [nb_front_end][nb_context]
+1	1	+1	# size_packet_id [2][1] [nb_front_end][nb_context]
+0	0	+1	# table_routing  [0][0] [nb_front_end][nb_context]
+1	1	+1	# table_routing  [1][0] [nb_front_end][nb_context]
+0	0	+1	# table_routing  [1][1] [nb_front_end][nb_context]
+1	1	+1	# table_routing  [1][2] [nb_front_end][nb_context]
+1	1	+1	# table_routing  [2][0] [nb_front_end][nb_context]
+0	0	+1	# table_routing  [2][1] [nb_front_end][nb_context]
+0	1	+1	# priority           
+0	1	+1	# load_balancing     
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/SelfTest/config_multi_front_end3.cfg
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/SelfTest/config_multi_front_end3.cfg	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/SelfTest/config_multi_front_end3.cfg	(revision 88)
@@ -0,0 +1,27 @@
+Icache_Access
+3	3	+1	# nb_front_end       
+1	1	+1	# nb_context     [0]    [nb_front_end]
+3	3	+1	# nb_context     [1]    [nb_front_end]
+2	2	+1	# nb_context     [2]    [nb_front_end]
+3	3	+1	# nb_icache_port
+30	30	+1	# size_address   
+1	1	+1	# nb_instruction [0][0] [nb_front_end][nb_context]
+2	2	+1	# nb_instruction [1][0] [nb_front_end][nb_context]
+3	3	+1	# nb_instruction [1][1] [nb_front_end][nb_context]
+2	2	+1	# nb_instruction [1][2] [nb_front_end][nb_context]
+4	4	+1	# nb_instruction [2][0] [nb_front_end][nb_context]
+4	4	+1	# nb_instruction [2][1] [nb_front_end][nb_context]
+2	2	+1	# size_packet_id [0][0] [nb_front_end][nb_context]
+3	3	+1	# size_packet_id [1][0] [nb_front_end][nb_context]
+3	3	+1	# size_packet_id [1][1] [nb_front_end][nb_context]
+0	0	+1	# size_packet_id [1][2] [nb_front_end][nb_context]
+1	1	+1	# size_packet_id [2][0] [nb_front_end][nb_context]
+1	1	+1	# size_packet_id [2][1] [nb_front_end][nb_context]
+2	2	+1	# table_routing  [0][0] [nb_front_end][nb_context]
+0	0	+1	# table_routing  [1][0] [nb_front_end][nb_context]
+1	1	+1	# table_routing  [1][1] [nb_front_end][nb_context]
+0	0	+1	# table_routing  [1][2] [nb_front_end][nb_context]
+1	1	+1	# table_routing  [2][0] [nb_front_end][nb_context]
+2	2	+1	# table_routing  [2][1] [nb_front_end][nb_context]
+0	1	+1	# priority           
+0	1	+1	# load_balancing     
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/SelfTest/config_multi_front_end4.cfg
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/SelfTest/config_multi_front_end4.cfg	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/SelfTest/config_multi_front_end4.cfg	(revision 88)
@@ -0,0 +1,27 @@
+Icache_Access
+3	3	+1	# nb_front_end       
+1	1	+1	# nb_context     [0]    [nb_front_end]
+3	3	+1	# nb_context     [1]    [nb_front_end]
+2	2	+1	# nb_context     [2]    [nb_front_end]
+4	4	+1	# nb_icache_port
+30	30	+1	# size_address   
+1	1	+1	# nb_instruction [0][0] [nb_front_end][nb_context]
+2	2	+1	# nb_instruction [1][0] [nb_front_end][nb_context]
+3	3	+1	# nb_instruction [1][1] [nb_front_end][nb_context]
+2	2	+1	# nb_instruction [1][2] [nb_front_end][nb_context]
+4	4	+1	# nb_instruction [2][0] [nb_front_end][nb_context]
+4	4	+1	# nb_instruction [2][1] [nb_front_end][nb_context]
+2	2	+1	# size_packet_id [0][0] [nb_front_end][nb_context]
+3	3	+1	# size_packet_id [1][0] [nb_front_end][nb_context]
+3	3	+1	# size_packet_id [1][1] [nb_front_end][nb_context]
+0	0	+1	# size_packet_id [1][2] [nb_front_end][nb_context]
+1	1	+1	# size_packet_id [2][0] [nb_front_end][nb_context]
+1	1	+1	# size_packet_id [2][1] [nb_front_end][nb_context]
+0	0	+1	# table_routing  [0][0] [nb_front_end][nb_context]
+1	1	+1	# table_routing  [1][0] [nb_front_end][nb_context]
+2	2	+1	# table_routing  [1][1] [nb_front_end][nb_context]
+3	3	+1	# table_routing  [1][2] [nb_front_end][nb_context]
+1	1	+1	# table_routing  [2][0] [nb_front_end][nb_context]
+0	0	+1	# table_routing  [2][1] [nb_front_end][nb_context]
+0	1	+1	# priority           
+0	1	+1	# load_balancing     
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/SelfTest/include/test.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/SelfTest/include/test.h	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/SelfTest/include/test.h	(revision 88)
@@ -0,0 +1,28 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ * Test "RegisterFile"
+ */
+
+#ifdef SYSTEMC
+#include "systemc.h"
+#endif
+
+#define NB_ITERATION  1024
+#define CYCLE_MAX     (1024*NB_ITERATION)
+
+#include "Common/include/Test.h"
+#include "Common/include/Time.h"
+#include "Behavioural/Core/Icache_Access/include/Icache_Access.h"
+
+using namespace std;
+using namespace morpheo;
+using namespace morpheo::behavioural;
+using namespace morpheo::behavioural::core;
+
+using namespace morpheo::behavioural::core::icache_access;
+
+void test    (string name,
+	      morpheo::behavioural::core::icache_access::Parameters * param);
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/SelfTest/src/main.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/SelfTest/src/main.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/SelfTest/src/main.cpp	(revision 88)
@@ -0,0 +1,157 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Icache_Access/SelfTest/include/test.h"
+#include "Common/include/Max.h"
+
+#define NB_PARAMS 5
+
+void usage (int argc, char * argv[])
+{
+  err (_("<Usage> %s name_instance list_params.\n"),argv[0]);
+  err (_("list_params is :\n"));
+  err (_(" * nb_front_end                              (uint32_t         )\n"));
+  err (_(" * nb_context     [nb_front_end]             (uint32_t         )\n"));
+  err (_(" * nb_icache_port                            (uint32_t         )\n"));
+  err (_(" * size_address                              (uint32_t         )\n"));
+  err (_(" * nb_instruction [nb_front_end][nb_context] (uint32_t         )\n"));
+  err (_(" * size_packet_id [nb_front_end][nb_context] (uint32_t         )\n"));
+  err (_(" * table_routing  [nb_front_end][nb_context] (uint32_t         )\n"));
+  err (_(" * priority                                  (Tpriority_t      )\n"));
+  err (_(" * load_balancing                            (Tload_balancing_t)\n"));
+
+  exit (1);
+}
+
+#ifndef SYSTEMC
+int main    (int argc, char * argv[])
+#else
+int sc_main (int argc, char * argv[])
+#endif
+{
+  if (argc <= static_cast<int>(2+NB_PARAMS))
+    usage (argc, argv);
+
+  uint32_t x = 1;
+
+  string name = argv[x++];
+
+  uint32_t             _nb_front_end           = fromString<uint32_t         >(argv[x++]);
+
+  if (argc <= static_cast<int>(2+NB_PARAMS+_nb_front_end))
+    usage (argc, argv);
+
+  uint32_t             _sum_nb_context         = 0;
+  uint32_t           * _nb_context             = new uint32_t [_nb_front_end];
+  for (uint32_t i=0; i<_nb_front_end; i++)
+    {
+      _nb_context [i] = fromString<uint32_t>(argv[x++]);
+      _sum_nb_context += _nb_context [i];
+    }
+
+  if (argc != static_cast<int>(2+NB_PARAMS+_nb_front_end+3*_sum_nb_context))
+    usage (argc, argv);
+      
+  uint32_t             _nb_icache_port         = fromString<uint32_t         >(argv[x++]);
+  uint32_t             _size_address           = fromString<uint32_t         >(argv[x++]);
+
+  uint32_t          ** _nb_instruction         = new uint32_t * [_nb_front_end];
+  uint32_t          ** _size_packet_id         = new uint32_t * [_nb_front_end];
+  uint32_t          ** _table_routing          = new uint32_t * [_nb_front_end];
+
+  for (uint32_t i=0; i<_nb_front_end; i++)
+    {
+      _nb_instruction [i] = new uint32_t [_nb_context[i]];
+      _size_packet_id [i] = new uint32_t [_nb_context[i]];
+      _table_routing  [i] = new uint32_t [_nb_context[i]];
+    }
+
+  for (uint32_t i=0; i<_nb_front_end; i++)
+    for (uint32_t j=0; j<_nb_context [i]; j++)
+      _nb_instruction [i][j] = fromString<uint32_t>(argv[x++]);
+
+  for (uint32_t i=0; i<_nb_front_end; i++)
+    for (uint32_t j=0; j<_nb_context [i]; j++)
+      _size_packet_id [i][j] = fromString<uint32_t>(argv[x++]);
+  
+  for (uint32_t i=0; i<_nb_front_end; i++)
+    for (uint32_t j=0; j<_nb_context [i]; j++)
+      _table_routing  [i][j] = fromString<uint32_t>(argv[x++]);
+  
+  Tpriority_t          _priority               = fromString<Tpriority_t      >(argv[x++]);
+  Tload_balancing_t    _load_balancing         = fromString<Tload_balancing_t>(argv[x++]);
+
+  uint32_t             _size_icache_thread_id  = log2(_nb_front_end) + log2(max<uint32_t>(_nb_context,_nb_front_end));;
+  uint32_t             _size_icache_packet_id  = max<uint32_t>(_size_packet_id,_nb_front_end, _nb_context);
+
+  uint32_t             _nb_thread              = 0;
+  uint32_t          ** _translate_context_to_thread = new uint32_t * [_nb_front_end];
+
+  for (uint32_t i=0; i<_nb_front_end; i++)
+    {
+      _translate_context_to_thread [i] = new uint32_t [_nb_context[i]];
+      for (uint32_t j=0; j<_nb_context[i]; ++j)
+        _translate_context_to_thread [i][j] = _nb_thread ++;
+    }
+
+  int _return = EXIT_SUCCESS;
+  try 
+    {
+      morpheo::behavioural::core::icache_access::Parameters * param = new morpheo::behavioural::core::icache_access::Parameters
+	(_nb_thread                  ,
+         _nb_front_end               ,
+	 _nb_context                 ,
+	 _nb_icache_port             ,
+	 _size_address               ,
+         _size_icache_thread_id      ,
+         _size_icache_packet_id      ,
+	 _nb_instruction             ,
+	 _size_packet_id             ,
+	 _table_routing              ,
+	 _priority                   ,
+	 _load_balancing             ,
+         _translate_context_to_thread
+         );
+      
+      msg(_("%s"),param->print(0).c_str());
+      
+      test (name,param);
+    }
+  catch (morpheo::ErrorMorpheo & error)
+    {
+      msg (_("<%s> :\n%s"),name.c_str(), error.what ());
+      _return = EXIT_FAILURE;
+    }
+  
+  try 
+    {
+      if (_return == EXIT_SUCCESS)
+	TEST_OK("Icache_Access : no error");
+      else
+	TEST_KO("Icache_Access : a lot of error");
+    }
+  catch (morpheo::ErrorMorpheo & error)
+    {
+//       msg (_("<%s> :\n%s"),name.c_str(), error.what ());
+      _return = EXIT_FAILURE;
+    }
+
+  delete [] _nb_context;
+  for (uint32_t i=0; i<_nb_front_end; i++)
+    {
+      delete [] _nb_instruction [i];
+      delete [] _size_packet_id [i];
+      delete [] _table_routing  [i];
+      delete [] _translate_context_to_thread [i];
+    }
+  delete [] _nb_instruction;
+  delete [] _size_packet_id;
+  delete [] _table_routing ;
+  delete [] _translate_context_to_thread;
+
+  return (_return);
+}
